%global momorel 7

%global require_ibus_version 1.3.2
%global macuim_ver svn187
%global protobuf_ver 2.3.0

Summary: Mozc support for IBus
Name: ibus-mozc
Version: 0.12.422.102
Release: %{momorel}m%{?dist}

# additional dictionaries by ut
%{?include_specopt}
%{?!with_utdic: %global with_utdic 0}

License: Modified BSD
URL: http://code.google.com/p/mozc/
Group: System Environment/Libraries
# See http://code.google.com/p/mozc/source/checkout
# Source0: %%{name}-%%{version}.tar.xz

Source0: http://mozc.googlecode.com/files/mozc-%{version}.tar.bz2
NoSource: 0

# Additional dictionaries by UTUMI Hirosi
# http://www.geocities.jp/ep3797/mozc_01.html
%if %{with_utdic}
%global utdicsrc mozcdic-ut-devel-20100731
Source1: http://www.geocities.jp/ep3797/snapshot/mozc/%{utdicsrc}.tar.bz2
NoSource: 1
%endif

# http://code.google.com/p/macuim/
# http://ekato.wordpress.com/2010/05/28/uim-mozc/
Source2: macuim-%{macuim_ver}.tar.lzma
Source3: protobuf-%{protobuf_ver}.tar.lzma

# imported from http://tomcat.nyanta.jp/linux/PCLOS/apt/pclos2010/SRPMS.nora/mozc-0.12.422.102-2nora102.nosrc.rpm
Source10: mozc-preference.desktop
Source11: mozc-dict.desktop

Source100: mozc-copyright

# imported from http://tomcat.nyanta.jp/linux/PCLOS/apt/pclos2010/SRPMS.nora/mozc-0.12.422.102-2nora102.nosrc.rpm
Patch0: mozc-%{version}-ipc-rollback.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: ibus >= %{require_ibus_version}
Requires: mozc-tools = %{version}-%{release}
BuildRequires: coreutils
BuildRequires: dbus-devel
BuildRequires: gcc
BuildRequires: gcc-c++
BuildRequires: glib-devel
BuildRequires: gyp
BuildRequires: ibus-devel
BuildRequires: kdelibs
BuildRequires: libcurl-devel
BuildRequires: openssl-devel
BuildRequires: p7zip
BuildRequires: python-devel
BuildRequires: qt-devel
BuildRequires: scim-devel
BuildRequires: uim-devel
BuildRequires: xz
BuildRequires: zlib-devel

%description
This package contains Mozc support for IBus.

%package -n mozc-server
Summary: Open source Google Japanese Input for IBus input platform
Group: System Environment/Libraries

%description -n mozc-server
Mozc is a Japanese Input Method Editor (IME) designed for
multi-platform such as Chromium OS, Windows, Mac and Linux.

%package -n mozc-tools
Summary: Mozc set up utilities
Group: System Environment/Libraries
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
Requires: mozc-server = %{version}-%{release}

%description -n mozc-tools
This package contains Mozc set up utilities.

%package -n scim-mozc
Summary: Mozc support for SCIM
Group: System Environment/Libraries
Requires: scim
Requires: mozc-tools = %{version}-%{release}

%description -n scim-mozc
This package contains Mozc support for SCIM.

%package -n uim-mozc
Summary: Mozc support for UIM
Group: System Environment/Libraries
Requires(post): uim
Requires: mozc-tools = %{version}-%{release}

%description -n uim-mozc
This package contains Mozc support for UIM.

%prep
%setup -q -n mozc-%{version} -a 2 -a3

# add ut dictionaries
%if %{with_utdic}
cp %{SOURCE1} .
tar jxf %{utdicsrc}.tar.bz2
pushd %{utdicsrc}
cat mozcdic-ut-* ../data/dictionary/dictionary1.txt \
  > dictionary1.txt.new
mv -f dictionary1.txt.new ../data/dictionary/dictionary1.txt
popd
%endif

# for uim support
cp -ar macuim-trunk/Mozc/uim unix/
mv protobuf-%{protobuf_ver} protobuf/files
patch -p0 < macuim-trunk/Mozc/mozc-kill-line.diff
patch -p0 < macuim-trunk/Mozc/mozc-linux-protobuf.diff

%patch0 -p1 -b .ipc-rollback

# for docs
cp %{SOURCE100} COPYING
chmod 644 data/installer/credits_*.html

%build
export CFLAGS="%{optflags}"
export CXXFLAGS="%{optflags}"
export QTDIR=`kde4-config --qt-prefix`
%{__python} build_mozc.py gyp --gypdir=%{_bindir}
%{__python} build_mozc.py build_tools -c Release
%{__python} build_mozc.py build -c Release \
    unix/ibus/ibus.gyp:ibus_mozc \
    unix/scim/ibus.gyp:scim_mozc \
    unix/scim/scim.gyp:scim_mozc_setup \
    unix/uim/uim.gyp:uim-mozc \
    server/server.gyp:mozc_server \
    gui/gui.gyp:mozc_tool

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

# install ibus support
mkdir -p %{buildroot}%{_prefix}/lib/ibus-mozc
install -m 755 out_linux/Release/ibus_mozc %{buildroot}%{_prefix}/lib/ibus-mozc/ibus-engine-mozc

mkdir -p %{buildroot}%{_datadir}/ibus/component
sed -e 's|/usr/libexec|%{_prefix}/lib/ibus-mozc|' \
    -e 's|<rank>0</rank>|<rank>90</rank>|' \
    < out_linux/Release/obj/gen/unix/ibus/mozc.xml > %{buildroot}%{_datadir}/ibus/component/mozc.xml

mkdir -p %{buildroot}%{_datadir}/ibus-mozc
install -m 644 data/images/unix/ime_product_icon_opensource-32.png %{buildroot}%{_datadir}/ibus-mozc/product_icon.png
install -m 644 data/images/unix/ui-tool.png %{buildroot}%{_datadir}/ibus-mozc/tool.png
install -m 644 data/images/unix/ui-properties.png %{buildroot}%{_datadir}/ibus-mozc/properties.png
install -m 644 data/images/unix/ui-dictionary.png %{buildroot}%{_datadir}/ibus-mozc/dictionary.png
install -m 644 data/images/unix/ui-direct.png %{buildroot}%{_datadir}/ibus-mozc/direct.png
install -m 644 data/images/unix/ui-hiragana.png %{buildroot}%{_datadir}/ibus-mozc/hiragana.png
install -m 644 data/images/unix/ui-katakana_half.png %{buildroot}%{_datadir}/ibus-mozc/katakana_half.png
install -m 644 data/images/unix/ui-katakana_full.png %{buildroot}%{_datadir}/ibus-mozc/katakana_full.png
install -m 644 data/images/unix/ui-alpha_half.png %{buildroot}%{_datadir}/ibus-mozc/alpha_half.png
install -m 644 data/images/unix/ui-alpha_full.png %{buildroot}%{_datadir}/ibus-mozc/alpha_full.png

# install scim support
mkdir -p %{buildroot}%{_libdir}/scim-1.0/1.4.0/IMEngine
install -m 755 out_linux/Release/lib.target/libscim_mozc.so %{buildroot}%{_libdir}/scim-1.0/1.4.0/IMEngine/mozc.so

mkdir -p %{buildroot}%{_libdir}/scim-1.0/1.4.0/SetupUI
install -m 755 out_linux/Release/lib.target/libscim_mozc_setup.so %{buildroot}%{_libdir}/scim-1.0/1.4.0/SetupUI/mozc-setup.so

mkdir -p %{buildroot}%{_datadir}/scim/icons
install -m 644 data/images/unix/ime_product_icon_opensource-32.png %{buildroot}%{_datadir}/scim/icons/scim-mozc.png
install -m 644 data/images/unix/ui-tool.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-tool.png
install -m 644 data/images/unix/ui-properties.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-properties.png
install -m 644 data/images/unix/ui-dictionary.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-dictionary.png
install -m 644 data/images/unix/ui-direct.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-direct.png
install -m 644 data/images/unix/ui-hiragana.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-hiragana.png
install -m 644 data/images/unix/ui-katakana_half.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-katakana_half.png
install -m 644 data/images/unix/ui-katakana_full.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-katakana_full.png
install -m 644 data/images/unix/ui-alpha_half.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-alpha_half.png
install -m 644 data/images/unix/ui-alpha_full.png %{buildroot}%{_datadir}/scim/icons/scim-mozc-alpha_full.png

# install uim support
mkdir -p %{buildroot}%{_libdir}/uim/plugin
mkdir -p %{buildroot}%{_datadir}/uim/pixmaps
install -m 755 out_linux/Release/libuim-mozc.so %{buildroot}%{_libdir}/uim/plugin/
install -m 644 macuim-trunk/Mozc/scm/*.scm %{buildroot}%{_datadir}/uim/
install -m 644 data/images/unix/ime_product_icon_opensource-32.png %{buildroot}%{_datadir}/uim/pixmaps/mozc.png

# install mozc-server and mozc-tools
mkdir -p %{buildroot}%{_prefix}/lib/mozc/documents
install -m 755 out_linux/Release/{mozc_server,mozc_tool} %{buildroot}%{_prefix}/lib/mozc/
install -m 644 data/installer/credits_en.html %{buildroot}%{_prefix}/lib/mozc/documents/
install -m 644 data/installer/credits_ja.html %{buildroot}%{_prefix}/lib/mozc/documents/

# install desktop files
mkdir -p %{buildroot}%{_datadir}/applications
install -m 644 %{SOURCE10} %{buildroot}%{_datadir}/applications/
install -m 644 %{SOURCE11} %{buildroot}%{_datadir}/applications/

# install icons
mkdir -p %{buildroot}%{_datadir}/pixmaps
install -m 644 data/images/unix/ui-dictionary.png %{buildroot}%{_datadir}/pixmaps/mozc-dictionary.png
install -m 644 data/images/unix/ui-properties.png %{buildroot}%{_datadir}/pixmaps/mozc-properties.png

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post -n mozc-tools
%{_bindir}/update-desktop-database %{_datadir}/applications &> /dev/null ||:

%postun -n mozc-tools
%{_bindir}/update-desktop-database %{_datadir}/applications &> /dev/null ||:

%post -n uim-mozc
%{_bindir}/uim-module-manager --register mozc > /dev/null 2> /dev/null || :

%files
%defattr(-,root,root,-)
%{_prefix}/lib/ibus-mozc
%{_datadir}/ibus/component/mozc.xml
%{_datadir}/ibus-mozc

%files -n mozc-server
%defattr(-,root,root,-)
%doc COPYING
%dir %{_prefix}/lib/mozc
%{_prefix}/lib/mozc/mozc_server
%{_prefix}/lib/mozc/documents/credits_*.html

%files -n mozc-tools
%defattr(-,root,root,-)
%{_prefix}/lib/mozc/mozc_tool
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/*.png

%files -n scim-mozc
%defattr(-,root,root,-)
%{_libdir}/scim-1.0/1.4.0/IMEngine/mozc.so
%{_libdir}/scim-1.0/1.4.0/SetupUI/mozc-setup.so
%{_datadir}/scim/icons/*.png

%files -n uim-mozc
%defattr(-,root,root,-)
%{_libdir}/uim/plugin/libuim-mozc.so
%{_datadir}/uim/pixmaps/mozc.png
%{_datadir}/uim/mozc*.scm

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.12.422.102-7m)
- full rebuild for mo7 release

* Thu Aug 12 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.12.422.102-6m)
- import ipc-rollback.patch from mozc-0.12.422.102-2nora102.nosrc.rpm
- http://tomcat.nyanta.jp/sb2/sb.cgi?eid=333
- thanks to tomcat

* Mon Aug  9 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.12.422.102-5m)
- fix path to credits_*.html

* Mon Aug  9 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.12.422.102-4m)
- increase rank to 90

* Mon Aug  9 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.12.422.102-3m)
- install icons and COPYING

* Sun Aug  8 2010 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.12.422.102-2m)
- split packages mozc-server and mozc-tools to correct dependencies
- add a package uim-mozc
- import mozc-dict.desktop and mozc-preference.desktop from mozc-0.12.422.102-2nora102.nosrc.rpm
- thanks to tomcat and ekato
- http://tomcat.nyanta.jp/sb2/sb.cgi?eid=324
- http://ekato.wordpress.com/2010/05/28/uim-mozc/
- change many lines of spec file, please check spec and test all sub-packages

* Sat Aug  7 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.12.422.102-1m)
- update 0.12.422.102

* Thu Jul 15 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.12.410.102-1m)
- update 0.12.410.102

* Mon Jul 12 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.12.402.102-2m)
- %%{optflags} should be used to ensure the RPM's architecture

* Thu Jul  1 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.12.402.102-1m)
- update 0.12.402.102

* Mon Jun 28 2010 NARITA Koichi <pulsar@momonga-linux.org>
- (0.11.383.102-2m)
- rebuild against qt-4.6.3-1m

* Wed Jun 23 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.11.383.102-1m)
- update 0.11.383.102
-- scim-support

* Tue Jun 15 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.365.102-3m)
- add specopt

* Mon Jun 14 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.365.102-2m)
- follow the upstream's debian/rules
-- install binaries into %%{_prefix}/lib
- utdic is optional, the default value is off
- get rid of mozc-config

* Thu Jun 10 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.11.365.102-1m)
- update to 0.11.365.102 tarball
- comment out Additional dictionaries 

* Mon May 24 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.0-1m)
- version is 0.11.0 (still svn revision 23)
- add mozc-config
- move ibus-engine-mozc to _libexecdir
- change icon image
- License: Modified BSD

* Sat May 22 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.11.23-1m)
- source update, 23 is svn revision now
- add icon.png but license is unknown

* Wed May 19 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.11.354-1m)
- source update

* Sun May 16 2010 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.11.351-5m)
- add some dictionaries

* Thu May 13 2010 NAITA Koichi <pulsar@momonga-linux.org>
- (0.11.351-4m)
- modify BuildRequires (kde4-config is owned by kdelibs)

* Thu May 13 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.11.351-3m)
- set qt4 QTDIR... Hmmm.. not linking qt4? 

* Tue May 11 2010 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.351-2m)
- add lib64 patch

* Tue May 11 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.11.351-1m)
- Initial commit Momonga Linux

